'FFSubmenu=Skalieren
'FFName=ScaleAll

'FFSkriptName=ScaleAll.vbs
'FFSkriptArchiv=ScaleAll.zip
'FFSkriptDirectory=\MeckiScript\ScaleAll
'FFSkriptFiles=\MeckiScript\ScaleAll\ScaleAll_Protokoll.txt;\MeckiScript\ScaleAll\ScaleAll.pdf;\MeckiScript\ScaleAll\rot.png;\MeckiScript\ScaleAll\gruen.png
'FFScriptProfile=FF_ScaleAll

'FFSkriptAuthor=Harald Maeckler
'FFSkriptVersion=1.42
'FFVersion=2.90.0
'FFSkriptURL=http://www.meckis-steckenpferde.de/FixFoto_Skripte.html

' ***********************************************************************
' ScaleAll.vbs (Script fr FixFoto)
' Funktion: Skalierung aller Bilder auf Vorgabewert fr lngste Seite
'
' Copyright Harald Maeckler, Dsseldorf 2009 - 2016
' ***********************************************************************
'
' Version 1.42 vom 27.03.2016	- Skript-URL gem Forenberarbeitung gendert
' Version 1.41 vom 06.01.2015 - defekte Bilddateien werden als solche erkannt und protokolliert
' Version 1.40 vom 05.08.2013 - nach zwangsweisem Abbruch wird beim nchsten Skriptstart
'								darauf hingewiesen und ermglicht die bis zum Abbruch
'								bearbeiteten Dateien aufzulisten
' Version 1.39 vom 31.07.2013 - im Protokoll bei 'Original lschen' auf GL statt UV korrigiert
'							  - 'Prfix' ersetzt durch 'Praefix'
' Version 1.38 vom 10.03.2013 - Bug beim Eintrag der Pixelgre in die Exif-Daten beseitigt
'							  - Updatefunktion gendert (jetzt mit Objekt "Microsoft.XMLHTTP")
' Version 1.37 vom 05.01.2013 - Nach erfolgreichem Durchlauf wird das Skript wieder automatisch beendet
' Version 1.36 vom 02.01.2013 - Ist bei 'Start' die Kontrolle negativ wird das Skript nicht mehr beendet
' Version 1.35 vom 31.12.2012 - Option 'Datum beibehalten' gendert
' Version 1.34 vom 22.12.2012 - Bug bei 'Original lschen' mit 'Speicherort Quellverzeichnis' beseitigt
'							  - Option 'Datum beibehalten' hinzugefgt
' Version 1.33 vom 11.09.2012 - Dialogdesign gendert
' Version 1.32 vom 18.03.2012 - Bug bei 'Orig. lschen/berschr.' beseitigt
' Version 1.31 vom 18.03.2012 - Tooltip zum Button 'Aktualisieren'
'							  - Versionsangabe ohne Rahmen
'							  - Abfangen des Fehlers bei gelschtem Zielverzeichnis
' Version 1.30 vom 16.03.2012 - Auswahl der Bildgre erweitert um 'Breite max. + max. Hhe'
'							  - Bug bei Wahl des Speicherorts unterhalb der Bildauswahlebene beseitigt
'							  - Bildauswahl statt mit 'objfolder.files' mit 'FF_GetSelection(0)'
'								auer bei 'alle im akt. Verz. +  den Unterverz."
'								um Filterung in der Computeransicht zu bercksichtigen
'								(Rcknahme der nderung in Version 1.16 durch andere Lsung -> S.6 #109 bis #116)
'							  - Anzeige der zu skalierenden Bilder abhngig von der Bildauswahl
'							  - nach Anlegen eines neuen Ordners
'								die Computeransicht auffrischen mit 'FF_SetImagePath()'
'							  - ein paar Tooltips hinzugefgt (ab FF 3.20.06)
'							  - Updatefunktion mit Fortschrittsanzeige hinzugefgt
'							  - diverse kleine nderungen
'							  - Kurzbeschreibung berarbeitet
' Version 1.24 vom 17.09.2011 - Bildfilter um JPEG erweitert
' Version 1.23 vom 08.09.2011 - Tooltip bei 'festes Verzeichnis' ab FF-Version 3.20.06
'							  - zustzlicher Fortschrittsbalken in der FF_Taskleiste 
' Version 1.22 vom 07.09.2011 - bei Auswahl 'festes Verzeichnis' wird der bisherige Ordner angezeigt
' Version 1.21 vom 07.09.2011 - Info-Taste fr Schrfeeinstellungen mit Farbmarkierung
'							  - Unterordner MeckiScript\ScaleAll erstellt fr Protokoll und pdf-KB
'							  - PDF-Kurzbeschreibung
' Version 1.20 vom 31.08.2011 -	TIF-Bilder werden jetzt immer komprimiert gespeichert
'							  - Schrfen mglich mit Wahl der Schrfemethode und den Parametern
' Version 1.19 vom 28.06.2011 -	gesichert gegen Absturz bei Speichern mit Exif-Daten
' Version 1.18 vom 04.11.2009 -	Bei Auswahl des Speicherorts "Festes Verzeichnis" wird 
'								das aktuelle Computerverzeichnis vorgegeben
' Version 1.17 vom 09.07.2009 -	Lschroutine hinzugefgt und KB entsprechend ergnzt
' Version 1.16 vom 30.04.2009 -	nderung 1.15 auch fr Unterverzeichnisse
' Version 1.15 vom 29.04.2009 -	wegen Rekursion bei Speicherkarte als Quellort
'								Zwischenspeicherung bei Auswahl 'alle Bilder im aktuellen Verzeichnis'
' Version 1.14 vom 21.04.2009 -	Skalierauswahl lngste Seite, krz. Seite, Breite max. oder Hhe max.
' Version 1.13 vom 19.03.2009 -	bei Bilderlisten als Quelle ist jetzt jeder Speicherort whlbar
'							  -	Bildfiltereingabe zur besseren Kontrolle gendert
'							  - bei 'alle Bilder im aktuellen Verzeichnis' und
'								bei 'alle im akt. Verz. +  den Unterverz.' werden alle Dateien kntrolliert,
'								nicht nur die von FixFoto frei gegebenen Dateien 
' Version 1.12 vom 18.03.2009 -	'nur kopieren' erfolgt jetzt in der Regel verlustfrei (siehe KB)
'							  -	am Protokollende wird der Beendigunsgszeitpunkt eingetragen
' Version 1.11 vom 13.03.2009 -	Protokoll erweitert um 'Nicht bearbeitete Dateien'
' Version 1.10 vom 12.03.2009 -	TIFF-Qualitt ersetzt durch TIFF-Komprimierung
'							  - Fortschrittsanzeige jetzt 6-stellig
'							  -	Bestehenden Zwang, das Original zu lschen bzw. zu berschreiben, 
'								wenn der Speicherort das Quellverzeichnis ist und weder Vor- noch Nachspann
'								gewhlt ist, entfernt. Bei nicht aktiertem 'Original lschen/berschreiben'
'								wird dann der Bildname nummeriert.
'							  -	Sonderfunktion 'nur kopieren' eingefhrt. Sie wird nicht wie alle anderen 
'								Einstellungen in der Registry gespeichert, muss also nach jedem Skriptaufruf
'								bei Bedarf erneut gesetzt werden.
'							  - berarbeitung der Protokollierung
'							  - berarbeitung der Kurzbeschreibung
' Version 1.09 vom 10.03.2009 -	Bug bei der Protokollerstellung beseitigt
' Version 1.08 vom 07.03.2009 -	auch schreibgeschtzte Dateien werden skaliert (s. Beschreibung)
' Version 1.07 vom 07.03.2009 -	Tiff-Qualitt 16bit entfernt
' Version 1.06 vom 06.03.2009 -	Kurzbeschreibung
' Version 1.05 vom 03.03.2009 -	Design gendert und Erweiterungen
'									Logdatei, Tiff-Qualitt, Unterverz. zum Quellverz. als Speicherort,
'									IPTC-Daten lschen, Bilder in der Bilderliste nur entfernen
' Version 1.04 vom 02.03.2009 -	Dateien werden berprft, ob sie noch existieren
'							  - existierende Dateinamen werden generell nummeriert
'							  -	wenn Bild bereits kleiner als verlangt und 'nur verkleinern" ist erlaubt,
'									wird das Bild behandelt als wre es bereits skaliert
' Version 1.03 vom 28.02.2009 -	Bug bei Aktualisierung von Bilderlisten beseitigt
' Version 1.02 vom 28.02.2009 -	Erweiterungen
' Version 1.01 vom 24.02.2009 -	Bug beim vorz. Abbruch beseitigt
' Version 1.00 vom 23.02.2009 -	Beta
' ***********************************************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.42"
const SkriptURL = "http://www.ffsf.de/resources/scaleall.163/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'TIFF-Komprimierung
const flag_TifLZW = 1 : const flag_TifUnkomp = 0

'Schrfen
const S_Arten = "Y-Schrfe|RGB-Schrfe|USM|Verformen|Kanten schrfen|Weichzeichner|3D-Schrfe"
S_Array = split(S_Arten,"|")
Dim S_ParBenennung(6,5),ParamWerte
S_ParBenennung(0,0) = "Schrfe"	'Y-Schrfe
S_ParBenennung(1,0) = "Schrfe"	'RGB-Schrfe
S_ParBenennung(1,1) = "Rot"
S_ParBenennung(1,2) = "Grn"
S_ParBenennung(1,3) = "Blau"
S_ParBenennung(2,0) = "Schrfe	"	'USM
S_ParBenennung(2,1) = "Radius x 10"
S_ParBenennung(2,2) = "Level	"
S_ParBenennung(2,3) = "Rot	"
S_ParBenennung(2,4) = "Grn	"
S_ParBenennung(2,5) = "Blau	"
S_ParBenennung(3,0) = "Wert"	'Verformen
S_ParBenennung(4,0) = "Schrfe"	'Kanten schrfen
S_ParBenennung(4,1) = "Radius"
S_ParBenennung(5,0) = "Mix"	'Weichzeichnen
S_ParBenennung(5,1) = "Radius"
S_ParBenennung(6,0) = "Farbschrfe"	'3D_Schrfe
S_ParBenennung(6,1) = "Grauanteil  "

Dim S_Array,S_element,S_Max,S_Nummer,S_Ergebnis,flag_Schaerfen,S_Wahl
Dim S_ParamListe,S_ListArray
S_Array = split(S_Arten,"|")
S_Max = ubound(S_Array)
Dim Info_rot,Info_gruen

const SkriptName = "ScaleAll.vbs"							'Skriptname
const ForReading = 1, ForWriting = 2, ForAppending = 8

Dim objFS,WshShell,objShell									'Objekte

'Dialogwerte
Dim SkriptKill,TempFile,Abbruch,Datum
Dim Array,Auswahl,flag_selBilder,flag_allBilder,flag_allBilderUV
Dim Speicherort,flag_OrdnerGleich,flag_OrdnerNeu,Selection
Dim Ablageordner,Bildlaenge,Bildhoehe,Bilderliste,Filteranzeige,flag_MaxHoehe
Dim BildHandling,flag_Praefix,flag_Suffix,flag_OrigLoeschen,flag_ExifLoeschen
Dim Praefix,Suffix,Qualitaet,Version,BildExtension,Speicherparameter,SpeicherExtension
Dim flag_selectInBL,flag_alleInBL,flag_auchBeiSchreibschutz,flag_nurVerkleinern,flag_Datum_bleibt,flag_speichernAls
Dim AnzahlZuKlein,AnzahlSkaliert,AnzahlGeschuetzt,AnzahlDefekt

const CropAuswahl = "lngste Seite/krz. Seite/Breite max./Hhe max./max.Breite +"
Dim Crop,CropArray

Const BildFilter = "BMP;JP2;JPG;PNG;TIF;JPEG"
Dim imagecount,objFolder,objSubFolder,Gesamtanzahl,OrdnerNeu : OrdnerNeu = false
Dim n,Bild,Bilderanzahl,Anzahl,Antwort,msg
Dim Pfad,Unterordner,Daten_Delete
Dim flag_Unterordner,flag_inBLnurEntfernen,flag_Protokoll
Dim flag_IPTCloeschen, flag_nurKopieren

Dim Prot_Zeile(14),Prot_Liste,Prot_Gesamt,Prot_Datei,Prot_NichtBearbeitet,Datei
Dim ProtAbb_Datei,DateiA

Dim Screenshot

const VerbZ = "/,\,:,*,?,<,>,|"	'in Dateinamen verbotene Zeichen und "
'------------------------------------------------------------------------
Screenshot = false	'Aktivierung ber Flag "Exif lschen"

Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")
Set objShell = CreateObject("Shell.Application")

call Main

Set objFS = nothing
Set WshShell = nothing
Set objShell = nothing
FF_SetImagePath Pfad	'Computerverzeichnnis auffrischen

'------------------------------------------------------------------------
Sub Main	'### Hauptprogramm
Dim OrdnerName,BildFilterKontrolle,BildfilterTemp,element,Text,Anzeige,pos

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

OrdnerName = FF_GetImagePath
if not objFS.FolderExists(OrdnerName) then
	msgbox "Der Ordner" & vbNewLine & OrdnerName & vbNewLine & "wurde gelscht." & vbNewLine & vbNewLine & _
		   "Das Computerverzeichnis wird jetzt aktualisiert" & vbNewLine & "und das Skript beendet.",vbExclamation,"Abbruch"
	do
		pos = InStrRev(OrdnerName,"\")
		if pos > 0 then
			OrdnerName = left(OrdnerName,pos -1)
			if objFS.FolderExists(OrdnerName) then exit do
		end if
	loop
	FF_SetImagePath OrdnerName
	exit sub
end if

if not Version_OK("2.90.00") then
	msgbox "Fr das Skript ist mindestens FF-Version 2.90 erforderlich!",vbCritical,"Abbruch"
	exit sub
end if

'Protokoll-Datei und Farbmarkierungen
Prot_Datei = FF_GetScriptPath() & "\MeckiScript\ScaleAll\ScaleAll_Protokoll.txt"
ProtAbb_Datei = FF_GetScriptPath() & "\MeckiScript\ScaleAll\ScaleAll_AbbProtokoll.txt"
Info_rot = FF_GetScriptPath & "\MeckiScript\ScaleAll\rot.png"
Info_gruen = FF_GetScriptPath & "\MeckiScript\ScaleAll\gruen.png"

if objFS.FileExists(ProtAbb_Datei) then
	Antwort = msgbox ("Beim letzten Skriptdurchlauf erfolgte" & vbNewLine & _
					  "ein zwangsweiser Abbruch." & vbNewLine & vbNewLine & _
					  "Sollen die bis zum Abbruch berabeiteten" & vbNewLine & _
					  "Dateien angezeigt werden?",vbYesNo + vbQuestion,"Abbruchprotokoll")
	if Antwort = vbYes then WshShell.Run "notepad " + ProtAbb_Datei,1,true
end if

'** Start Dialog ScaleAll **
FF_AddDialog "ScaleAll",322,187
FF_AddControl "ScaleAll","Bilderauswahl","GROUP",6,6,137,83
FF_AddControl "ScaleAll","flag_selBilder","BOOL",10,13,8,8
FF_SetControlStyle "ScaleAll","flag_selBilder",16384
FF_AddControl "ScaleAll","selektierte im aktuellen Verzeichnis","STATIC",23,12,83,11
FF_AddControl "ScaleAll","flag_allBilder","BOOL",10,22,8,8
FF_SetControlStyle "ScaleAll","flag_allBilder",16384
FF_AddControl "ScaleAll","alle Bilder im aktuellen Verzeichnis","STATIC",23,21,84,10
FF_AddControl "ScaleAll","flag_allBilderUV","BOOL",10,31,8,8
FF_SetControlStyle "ScaleAll","flag_allBilderUV",16384
FF_AddControl "ScaleAll","alle im aktuellen Verzeichnis +  den Unterordnern","STATIC",23,30,119,10
FF_AddControl "ScaleAll","flag_selectInBL","BOOL",10,40,8,8
FF_SetControlStyle "ScaleAll","flag_selectInBL",16384
FF_AddControl "ScaleAll","selektierte Bilder der aktuellen Bilderliste","STATIC",23,39,100,10
FF_AddControl "ScaleAll","flag_alleInBL","BOOL",10,49,8,8
FF_SetControlStyle "ScaleAll","flag_alleInBL",16384
FF_AddControl "ScaleAll","alle Bilder der aktuellen Bilderliste","STATIC",23,48,84,10
FF_AddControl "ScaleAll","Bildfilter (zugelassene Dateierweiterungen):","STATIC",10,65,116,9
FF_AddControl "ScaleAll","BildExtension","SLEDIT",10,75,88,10
FF_SetControlStyle "ScaleAll","BildExtension",2049
FF_AddControl "ScaleAll","Standard","BUTTON",101,75,25,10
FF_AddControl "ScaleAll","||...","BUTTON",127,75,12,10
FF_AddControl "ScaleAll","Speicherort","GROUP",6,91,137,63
FF_AddControl "ScaleAll","flag_OrdnerGleich","BOOL",10,100,8,8
FF_SetControlStyle "ScaleAll","flag_OrdnerGleich",16384
FF_AddControl "ScaleAll","Quellverzeichnis beibehalten","STATIC",23,99,74,10
FF_AddControl "ScaleAll","flag_Unterordner","BOOL",10,109,8,8
FF_SetControlStyle "ScaleAll","flag_Unterordner",16384
FF_AddControl "ScaleAll","Unterverzeichnis des Quellverzeichnisses","STATIC",23,108,90,10
FF_AddControl "ScaleAll","Unterordner","SLEDIT",10,118,129,10
FF_SetControlStyle "ScaleAll","Unterordner",2048
FF_AddControl "ScaleAll","|...","BUTTON",127,107,12,10
FF_AddControl "ScaleAll","flag_OrdnerNeu","BOOL",10,130,8,9
FF_SetControlStyle "ScaleAll","flag_OrdnerNeu",16384
FF_AddControl "ScaleAll","festes Verzeichnis:","STATIC",23,129,72,10
FF_AddControl "ScaleAll","Ablageordner","SLEDIT",10,140,129,10
FF_SetControlStyle "ScaleAll","Ablageordner",2048
FF_AddControl "ScaleAll","...","BUTTON",127,129,12,10
FF_AddControl "ScaleAll","Speicherparameter","GROUP",148,6,104,148
FF_AddControl "ScaleAll","Skalierwert","COMBO",152,15,46,10
FF_AddControl "ScaleAll","px","STATIC",199,15,8,10
FF_SetControlStyle "ScaleAll","px",1
FF_AddControl "ScaleAll","Lnge","SLEDIT",208,15,18,10
FF_SetControlStyle "ScaleAll","Lnge",8194
FF_AddControl "ScaleAll","flag_Praefix","BOOL",152,40,8,8
FF_SetControlStyle "ScaleAll","flag_Praefix",16384
FF_AddControl "ScaleAll","Vorspann","STATIC",163,39,24,10
FF_AddControl "ScaleAll","Prfix","EDIT",194,39,32,10
FF_SetControlStyle "ScaleAll","Prfix",0
FF_AddControl "ScaleAll","flag_Suffix","BOOL",152,52,8,8
FF_SetControlStyle "ScaleAll","flag_Suffix",16384
FF_AddControl "ScaleAll","Nachspann","STATIC",163,51,28,10
FF_AddControl "ScaleAll","Suffix","EDIT",194,51,32,10
FF_SetControlStyle "ScaleAll","Suffix",2
FF_AddControl "ScaleAll","Strich3","STATIC",152,63,97,4
FF_SetControlStyle "ScaleAll","Strich3",7
FF_AddControl "ScaleAll","flag_OrigLschen","BOOL",152,70,8,8
FF_SetControlStyle "ScaleAll","flag_OrigLschen",16384
FF_AddControl "ScaleAll","Original lschen/berschreiben","STATIC",163,68,76,10
FF_AddControl "ScaleAll","flag_auchBeiSchreibschutz","BOOL",163,79,8,8
FF_AddControl "ScaleAll","auch schreibgeschtzt","STATIC",175,78,63,10
FF_AddControl "ScaleAll","flag_inBLnurEntfernen","BOOL",152,88,8,8
FF_SetControlStyle "ScaleAll","flag_inBLnurEntfernen",16384
FF_AddControl "ScaleAll","Darstellung aus Bilderliste entfernen","STATIC",163,87,88,10
FF_AddControl "ScaleAll","Strich4","STATIC",152,97,97,4
FF_SetControlStyle "ScaleAll","Strich4",7
FF_AddControl "ScaleAll","flag_nurVerkleinern","BOOL",152,103,8,8
FF_AddControl "ScaleAll","nur kleiner","STATIC",163,102,25,10
FF_AddControl "ScaleAll","flag_speichernAls","BOOL",152,113,8,8
FF_AddControl "ScaleAll","immer speichern als:","STATIC",163,111,62,11
FF_AddControl "ScaleAll","SpeicherExtension","COMBO",152,122,33,10
FF_AddControl "ScaleAll","- Datei","STATIC",188,122,28,10
FF_AddControl "ScaleAll","Strich5","STATIC",152,134,97,4
FF_SetControlStyle "ScaleAll","Strich5",7
FF_AddControl "ScaleAll","flag_Protokoll","BOOL",152,142,8,8
FF_AddControl "ScaleAll","Protokoll anlegen","STATIC",163,140,62,11
FF_AddControl "ScaleAll","JPEG-Qualitt","GROUP",257,6,59,35
FF_AddControl "ScaleAll","QualittsWert","SLEDIT",265,16,19,10
FF_SetControlStyle "ScaleAll","QualittsWert",8194
FF_AddControl "ScaleAll","60 - 100","STATIC",287,16,25,11
FF_AddControl "ScaleAll","0 = FF-Einstellung","STATIC",266,26,46,12
FF_AddControl "ScaleAll","Schrfen","GROUP",257,44,59,37
FF_AddControl "ScaleAll","flag_Schaerfen","BOOL",303,43,8,9
FF_SetControlStyle "ScaleAll","flag_Schaerfen",16384
FF_AddControl "ScaleAll","S_Auswahl","COMBO",260,53,52,10
FF_AddControl "ScaleAll","Einstellen","BUTTON",260,66,28,11
FF_AddControl "ScaleAll","Info","BUTTON",294,66,18,11
FF_AddControl "ScaleAll","Exif / IPTC","GROUP",257,81,59,32
FF_AddControl "ScaleAll","flag_ExifLschen","BOOL",265,91,8,8
FF_SetControlStyle "ScaleAll","flag_ExifLschen",16384
FF_AddControl "ScaleAll","Exif lschen","STATIC",276,90,35,11
FF_AddControl "ScaleAll","flag_IPTClschen","BOOL",265,100,8,8
FF_AddControl "ScaleAll","IPTC lschen","STATIC",276,99,35,11
FF_AddControl "ScaleAll","Sonderfunktion","GROUP",257,113,59,20
FF_AddControl "ScaleAll","flag_nurKopieren","BOOL",265,122,8,8
FF_SetControlStyle "ScaleAll","flag_nurKopieren",16384
FF_AddControl "ScaleAll","nur kopieren","STATIC",276,120,35,11
FF_AddControl "ScaleAll","Fortschritt","STATIC",273,133,27,11
FF_SetControlStyle "ScaleAll","Fortschritt",1
FF_AddControl "ScaleAll","ZahlBearbeitet","SLEDIT",257,144,24,10
FF_SetControlStyle "ScaleAll","ZahlBearbeitet",2049
FF_AddControl "ScaleAll","von","STATIC",281,144,11,10
FF_AddControl "ScaleAll","ZahlGesamt","SLEDIT",292,144,24,10
FF_SetControlStyle "ScaleAll","ZahlGesamt",2049
FF_SetControlStyle "ScaleAll","von",1
FF_AddControl "ScaleAll","FortschrittAnzeige","PROGRESS",6,159,310,8
FF_AddControl "ScaleAll","?","BUTTON",13,173,11,11
FF_AddControl "ScaleAll","Abbrechen mit","STATIC",113,173,36,11
FF_SetControlStyle "ScaleAll","Abbrechen mit",1
FF_AddControl "ScaleAll","Anzeigen","BUTTON",208,140,30,10
FF_AddControl "ScaleAll","Beenden","BUTTON",235,173,33,11
FF_AddControl "ScaleAll","Start","BUTTON",274,173,33,11
FF_AddControl "ScaleAll","&d","BUTTON",21,175,1,1
FF_AddControl "ScaleAll","Info_K","IMAGE",289,66,4,11
FF_AddControl "ScaleAll","HheMax","SLEDIT",208,27,18,10
FF_SetControlStyle "ScaleAll","HheMax",8194
FF_AddControl "ScaleAll","max. Hhe","STATIC",163,27,28,10
FF_AddControl "ScaleAll","px|","STATIC",199,27,8,10
FF_SetControlStyle "ScaleAll","px|",1
FF_AddControl "ScaleAll","Backspace","BUTTON",150,174,32,9
FF_AddControl "ScaleAll","- Taste","STATIC",184,173,20,11
FF_AddControl "ScaleAll","Update","BUTTON",52,173,33,11
FF_AddControl "ScaleAll","flag_MaxHoehe","BOOL",152,28,8,8
FF_AddControl "ScaleAll","Strich2","STATIC",10,59,130,4
FF_SetControlStyle "ScaleAll","Strich2",7
FF_AddControl "ScaleAll","Aktualisieren","BUTTON",104,3,33,10
FF_AddControl "ScaleAll","|","STATIC",26,173,24,11
FF_SetControlStyle "ScaleAll","|",1
FF_AddControl "ScaleAll","flag_Datum_bleibt","BOOL",193,103,8,8
FF_AddControl "ScaleAll","Datum beibehalten","STATIC",203,102,48,10
'** End Dialog ScaleAll **

for each S_element in S_Array
	FF_SetControl "ScaleAll","S_Auswahl",S_element
next

call RegistryLesen

if Version_OK("3.30.06") then
	FF_SetControlTooltip "ScaleAll","Aktualisieren", "" &_
						 "Aktualisiert die Anzahl der zu bearbeitenden" & vbNewLine & _
						 "Bilder nach Verzeichniswechsel oder" & vbNewLine & _
						 "vernderter Bildauswahl"
	FF_SetControlTooltip "ScaleAll","Ablageordner",Ablageordner
	FF_SetControlTooltip "ScaleAll","Anzeigen", "" &_
						 "Anzeige des Protokolls"
	FF_SetControlTooltip "ScaleAll","?", "" &_
						 "Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & _
						 "vorausgesetzt es ist ein PDF-Reader installiert."
	FF_SetControlTooltip "ScaleAll","Update", "" &_
						 "Prfung ob eine neue Version vorliegt."
	FF_SetControlTooltip "ScaleAll","Backspace", "" &_
						 "Vorzeitiger Abbruch mglich durch" & vbNewLine & _
						 "Festhalten der 'Backspace'-Taste bis" & vbNewLine &_
						 "eine Rckmeldung erfolgt."
end if

call Info_RotGruen

FF_EnableControl "ScaleAll","flag_MaxHoehe",false
FF_ActivateControl "ScaleAll","&d"
FF_SetDialogTimer "ScaleAll", 100

do
	call Anzeige_Aktuell
	
	Select Case FF_ShowDialog ("ScaleAll")
	Case "&d"
		Abbruch = false
		SkriptKill = false
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "mit allen dazugehrigen Komponenten wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "TIMER"
		FF_SetControl "ScaleAll" ,"|","V " & SkriptVersion
		FF_SetDialogTimer "ScaleAll", 0
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Aktualisieren"
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'0 = alle Dateien der Computeransicht
'1 = selektierte Dateien der Computeransicht
'2 = alle Dateien der aktuellen Bilderliste
'3 = selektierte Dateien der aktuellen Bilderliste
'4 = Sonder: alle im akt. Verz. und den Unterverz.
	Case "flag_selBilder"
		FF_SetControl "ScaleAll","flag_selBilder",1
		FF_SetControl "ScaleAll","flag_allBilder",0
		FF_SetControl "ScaleAll","flag_allBilderUV",0
		FF_SetControl "ScaleAll","flag_selectInBL",0
		FF_SetControl "ScaleAll","flag_alleInBL",0
		FF_EnableControl "ScaleAll","flag_inBLnurEntfernen",false
		Selection = 1
	Case "flag_allBilder"
		FF_SetControl "ScaleAll","flag_selBilder",0
		FF_SetControl "ScaleAll","flag_allBilder",1
		FF_SetControl "ScaleAll","flag_allBilderUV",0
		FF_SetControl "ScaleAll","flag_selectInBL",0
		FF_SetControl "ScaleAll","flag_alleInBL",0
		FF_EnableControl "ScaleAll","flag_inBLnurEntfernen",false
		Selection = 0
	Case "flag_allBilderUV"
		FF_SetControl "ScaleAll","flag_selBilder",0
		FF_SetControl "ScaleAll","flag_allBilder",0
		FF_SetControl "ScaleAll","flag_allBilderUV",1
		FF_SetControl "ScaleAll","flag_selectInBL",0
		FF_SetControl "ScaleAll","flag_alleInBL",0
		FF_EnableControl "ScaleAll","flag_inBLnurEntfernen",false
		Selection = 4
	Case "flag_selectInBL"
		FF_SetControl "ScaleAll","flag_selBilder",0
		FF_SetControl "ScaleAll","flag_allBilder",0
		FF_SetControl "ScaleAll","flag_allBilderUV",0
		FF_SetControl "ScaleAll","flag_selectInBL",1
		FF_SetControl "ScaleAll","flag_alleInBL",0
		FF_EnableControl "ScaleAll","flag_inBLnurEntfernen",true
		FF_SetControl "ScaleAll","flag_OrigLschen",0
		FF_EnableControl "ScaleAll","flag_auchBeiSchreibschutz",false
		Selection = 3
	Case "flag_alleInBL"
		FF_SetControl "ScaleAll","flag_selBilder",0
		FF_SetControl "ScaleAll","flag_allBilder",0
		FF_SetControl "ScaleAll","flag_allBilderUV",0
		FF_SetControl "ScaleAll","flag_selectInBL",0
		FF_SetControl "ScaleAll","flag_alleInBL",1
		FF_EnableControl "ScaleAll","flag_inBLnurEntfernen",true
		FF_SetControl "ScaleAll","flag_OrigLschen",0
		FF_EnableControl "ScaleAll","flag_auchBeiSchreibschutz",false
		Selection = 2
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	Case "Standard"
		FF_SetControl "ScaleAll","BildExtension",BildFilter
	Case "||..."		'Bildfiltereingabe
		do
			BildfilterTemp = inputbox("Eingabe der zugelassenen Dateierweiterungen" & vbNewLine & "nach dem Schema" & vbNewLine & _
						 BildFilter,"Bildfilter",FF_GetControl("ScaleAll","BildExtension"))
			if BildfilterTemp = "" then exit do
			
			BildFilterKontrolle = ";" & BildFilter & ";"
			Array = split(BildfilterTemp,";")
			BildfilterTemp = ""
			for each element in Array
				if instr(BildFilterKontrolle,";" & ucase(element) & ";") > 0 then
					BildfilterTemp = BildfilterTemp & ";" & ucase(element)
				end if
			next
			if BildfilterTemp = "" then
				msgbox "Die eingegebene Dateierweiterung ist nicht zulssig." & vbNewLine & _
					   "Bitte korrigieren!",vbCritical,"Korrektur"
			else
				BildfilterTemp = mid(BildfilterTemp,2)
				exit do
			end if
		loop
		if BildfilterTemp <> "" then FF_SetControl "ScaleAll","BildExtension",BildfilterTemp
	Case "flag_OrdnerGleich"
		FF_SetControl "ScaleAll","flag_OrdnerGleich",1
		FF_SetControl "ScaleAll","flag_Unterordner",0
		FF_SetControl "ScaleAll","flag_OrdnerNeu",0
	Case "flag_Unterordner"
		FF_SetControl "ScaleAll","flag_OrdnerGleich",0
		FF_SetControl "ScaleAll","flag_Unterordner",1
		FF_SetControl "ScaleAll","flag_OrdnerNeu",0
	Case "flag_OrdnerNeu"
		FF_SetControl "ScaleAll","flag_OrdnerGleich",0
		FF_SetControl "ScaleAll","flag_Unterordner",0
		FF_SetControl "ScaleAll","flag_OrdnerNeu",1
	Case "|..."			'Eingabe Unterordner zum Quellverzeichnis als Speicherort
		do
			Abbruch = false
			Unterordner = inputbox("Eingabe des Unterordners" & vbNewLine & "nach dem Schema" & vbNewLine & _
						 "\Unterordner","Unterordner",FF_GetControl("ScaleAll","Unterordner"))
			if Unterordner = "" then exit do
			if left(Unterordner,1) <> "\" then
				msgbox "Die Bezeichnung des Unterordners muss mit " & """\""" & " beginnen!",vbExclamation,"Hinweis"
				Abbruch = true
			else
				if not ZulaessigeZeichen (mid(Unterordner,2)) then
					msgbox "Die Zeichen " & VerbZ & " drfen nicht verwendet werden!",vbExclamation,"Hinweis"
					Abbruch = true
				end if
			end if
			if not Abbruch then exit do
		loop
		if len(Unterordner) > 1 then FF_SetControl "ScaleAll","Unterordner",Unterordner
	Case "..."			'Auswahl festes Verzeichnis als Speicherort
		FF_SetCurrentPath Ablageordner
		OrdnerName = FF_EnterPath(false,"Wahl des Ablageordners")
		if len(OrdnerName) > 2 then
			Ablageordner = OrdnerName
			FF_SetControl "ScaleAll","Ablageordner",Ablageordner
			if Version_OK("3.30.06") then
				FF_SetControlTooltip "ScaleAll","Ablageordner",Ablageordner
			end if
		end if
	Case "Skalierwert"
		if FF_GetControl("ScaleAll","Skalierwert") = "max.Breite +" then
			FF_SetControl "ScaleAll","flag_MaxHoehe",1
			FF_EnableControl "ScaleAll","HheMax",true
		else
			FF_SetControl "ScaleAll","flag_MaxHoehe",0
			FF_EnableControl "ScaleAll","HheMax",false
		end if
	Case "flag_Praefix"
		if FF_GetControl("ScaleAll","flag_Praefix") = 1 then
			FF_SetControl "ScaleAll","flag_Suffix",0
		end if
	Case "flag_Suffix"
		if FF_GetControl("ScaleAll","flag_Suffix") = 1 then
			FF_SetControl "ScaleAll","flag_Praefix",0
		end if		
	Case "flag_OrigLschen"
		if FF_GetControl("ScaleAll","flag_OrigLschen") = 1 then
			FF_EnableControl "ScaleAll","flag_auchBeiSchreibschutz",true
			if FF_GetControl("ScaleAll","flag_selectInBL") = 1 or FF_GetControl("ScaleAll","flag_alleInBL") = 1 then
				FF_SetControl "ScaleAll","flag_inBLnurEntfernen",0
			end if
			if FF_GetControl("ScaleAll","flag_OrdnerGleich") = 1 then
				if FF_GetControl("ScaleAll","flag_Praefix") = 1 or FF_GetControl("ScaleAll","flag_Suffix")  = 1 then
					msgbox "Achtung: Die Originalbilder werden" & vbNewLine & _
						   "ohne Rckfrage gelscht!",vbExclamation,"Warnung"
				else
					msgbox "Achtung: Ohne Vorspann oder Nachspann" & vbNewLine & _
						   "werden die Originalbilder ohne" & vbNewLine & _
					       "Rckfrage berschrieben!",vbExclamation,"Warnung"
				end if
			else
					msgbox "Achtung: Die Originalbilder werden" & vbNewLine & _
						   "ohne Rckfrage gelscht!",vbExclamation,"Warnung"
			end if	
		else
			FF_EnableControl "ScaleAll","flag_auchBeiSchreibschutz",false
		end if
	Case "flag_inBLnurEntfernen"
		if FF_GetControl("ScaleAll","flag_inBLnurEntfernen") = 1 then
			FF_SetControl "ScaleAll","flag_OrigLschen",0
			FF_EnableControl "ScaleAll","flag_auchBeiSchreibschutz",false
		end if
	Case "flag_Schaerfen","S_Auswahl"
		call Info_RotGruen
	Case "Einstellen"
		if FF_GetImageWidth = 0 then
			msgbox	"Zur Einstellung der Schrfeparameter" & vbNewline & _
					"muss ein Bild geladen sein!",vbExclamation,"Abbruch"
		else
			call Werte_Auslesen
			FF_SetParam S_ListArray(S_Nummer)
			S_Ergebnis = FF_MultiDialog("MultiSharp",S_Nummer)
			if S_Ergebnis >= 0 then
				S_ListArray(S_Nummer) = FF_GetParam
				ParamWerte = split(FF_GetParam,",")
				Text = ""
				for n = 0 to ubound(ParamWerte)
					Text = Text & vbNewLine & "	" & S_ParBenennung(S_Nummer,n) & "	" & ParamWerte(n)
				next
				Text =  "Zu '" & S_Array(S_Nummer) & "' wurden folgende Parameter abgespeichert:" & vbNewLine & Text
				msgbox  Text,vbInformation,"Schrfeparameter"
			end if

			call Info_RotGruen
		end if
	Case "Info"
		call Werte_Auslesen
		if len(S_ListArray(S_Nummer)) = 0 then
			Text = "Zu '" & S_Array(S_Nummer) & "' liegen keine Einstellwerte vor!"
		else
			ParamWerte = split(S_ListArray(S_Nummer),",")
			Text = ""
			for n = 0 to ubound(ParamWerte)
				Text = Text & vbNewLine & "	" & S_ParBenennung(S_Nummer,n) & "	" & ParamWerte(n)
			next
			Text =  "Zu '" & S_Array(S_Nummer) & "' wurden folgende Parameter abgespeichert:" & vbNewLine & Text
		end if
		msgbox  Text,vbInformation,"Schrfeparameter"
	Case "flag_ExifLschen"		'Pseudofortschritt fr Sceenshot
		if Screenshot then
			FF_SetControl "ScaleAll","ZahlBearbeitet",47253
			FF_SetControl "ScaleAll","ZahlGesamt",152883
			FF_SetControl "ScaleAll","FortschrittAnzeige",47253/152883*100
			FF_RefreshDialog("ScaleAll")
		end if
	Case "flag_nurKopieren"
		if FF_GetControl("ScaleAll","flag_nurKopieren") = 1 then
			FF_EnableControl "ScaleAll","Lnge",false
			FF_EnableControl "ScaleAll","flag_nurVerkleinern",false
		else
			FF_EnableControl "ScaleAll","Lnge",true
			FF_EnableControl "ScaleAll","flag_nurVerkleinern",true
		end if
	Case "Start"
		call Werte_Auslesen
		call Kontrolle
		if not Abbruch then
			call BilderGesamtzahl
			if Gesamtanzahl = 0 then
				msgbox "Es sind keine Dateien ausgewhlt!",vbExclamation,"Hinweis"
			else
				Antwort = msgbox ("Es werden insgesamt " & Gesamtanzahl & " Dateien darauf berprft, ob es sich um" & vbNewLine & _
					   Filteranzeige & " Bilddateien handelt." & vbNewLine & "Diese werden ggf. bearbeitet." & _
					   vbNewLine & vbNewLine & _
					   "Der Vorgang kann jederzeit mit der Backspace-Taste unterbrochen werden.",vbOkCancel,"Hinweis")
				if Antwort = vbCancel then exit do
	
				Prot_Liste = "" : Prot_NichtBearbeitet = ""
				call RegistrySchreiben
				
				Set DateiA = objFS.OpenTextFile(ProtAbb_Datei, ForWriting, true)
				DateiA.Write "Vor dem Abbruch wurden folgende Bilder bearbeitet:" & vbNewLine & vbNewLine
				DateiA.Close
				
				Set DateiA = objFS.OpenTextFile(ProtAbb_Datei, ForAppending, true)	'Abbruch-Protokoll
				call ScaleSchleife
				DateiA.Close
				if objFS.FileExists(ProtAbb_Datei) then objFS.DeleteFile ProtAbb_Datei,true

				if flag_selectInBL = 1 or flag_alleInBL = 1 then FF_IListUpdate(Bilderliste)
				if flag_Protokoll = 1 then call ProtokollErstellung					
	
				if Abbruch then
					msgbox "Die Bearbeitung wird vorzeitig abgebrochen!",vbInformation,"Hinweis"
				else
					if Bilderanzahl = 0 then
						msg = "Von den " & Gesamtanzahl & " Dateien entspricht keins dem Bildfilter " & BildExtension & "."
					else
						msg = "Von den " & Gesamtanzahl & " Dateien entsprechen " & Bilderanzahl & _
						   	  " dem Bildfilter" & vbNewline & "   " & BildExtension & " ." & vbNewLine
						if AnzahlGeschuetzt > 0 then
							msg = msg & "Davon waren " & AnzahlGeschuetzt & " Bilder schreibgeschtzt." & vbNewLine 
						end if
						msg = msg & vbNewline
						if AnzahlZuKlein = 1 then
							msg = msg & 1 & " Bild war schon kleiner als gefordert." & vbNewLine
						elseif AnzahlZuKlein > 0 then
							msg = msg & AnzahlZuKlein & " Bilder waren schon kleiner als gefordert." & vbNewLine
						end if
						if AnzahlDefekt = 1 then
							msg = msg & 1 & " Bild ist defekt." & vbNewLine
						elseif AnzahlDefekt > 0 then
							msg = msg & AnzahlDefekt & " Bilder sind defekt." & vbNewLine
						end if						
						msg = msg & vbNewline & "Es wurden insgesamt " & AnzahlSkaliert & " Bilder bearbeitet und gespeichert."
					end if
					
					if flag_Protokoll = 1 then
						msg = msg & vbNewLine & vbNewLine & "Soll das vollstandige Protokoll angezeigt werden?"
						Antwort = msgbox(msg,vbYesNo,"Schlussmeldung")
							if Antwort = vbYes then
								if objFS.FileExists(Prot_Datei) then
									WshShell.Run "notepad " + Prot_Datei,1,false
								else
									msgbox "Es wurde noch keine Protokolldatei erstellt!",vbInformation,"Hinweis"
								end if
							end if
					else
						msgbox msg,vbInformation,"Schlussmeldung"
					end if
				end if
			end if
			exit do
		end if
	Case "?"	'Kurzbeschreibung
		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\ScaleAll\ScaleAll.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht geffnet werden." & vbNewLine & _
				   "Mglicherweise wurde die PDF-Datei gelscht oder" & vbNewLine & _
				   "es ist kein PDF-Reader installiert (?).",vbExclamation,"Hinweis"
			err.clear
		end if
		on error GoTo 0
	Case "Anzeigen"
		if objFS.FileExists(Prot_Datei) then
			WshShell.Run "notepad " + Prot_Datei,1,false
		else
			msgbox "Es wurde noch keine Protokolldatei erstellt!",vbInformation,"Hinweis"
		end if
	Case "CANCEL", "Beenden"
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("ScaleAll")
if SkriptKill then call KillSkript	'ggf. Skript komplett entfernen

End Sub
'------------------------------------------------------------------------
Sub Anzeige_Aktuell

if not Screenshot then call BilderGesamtzahl

if Version_OK("3.30.06") then
	FF_SetControlTooltip "ScaleAll","flag_selBilder",FF_GetImagePath
	FF_SetControlTooltip "ScaleAll","flag_allBilder",FF_GetImagePath
	FF_SetControlTooltip "ScaleAll","flag_allBilderUV","beginnend mit " & FF_GetImagePath
	FF_SetControlTooltip "ScaleAll","flag_selectInBL",FF_IListGetCurrentList
	FF_SetControlTooltip "ScaleAll","flag_alleInBL",FF_IListGetCurrentList
end if


End Sub
'------------------------------------------------------------------------
Sub Info_RotGruen

call Werte_Auslesen
if flag_Schaerfen = 1 then
		if len(S_ListArray(S_Nummer)) = 0 then
			FF_SetControl "ScaleAll","Info_K",Info_rot
		else
			FF_SetControl "ScaleAll","Info_K",Info_gruen
		end if
	else
		FF_SetControl "ScaleAll","Info_K",""
end if

End Sub
'------------------------------------------------------------------------
Sub Kontrolle
'Sind alle Werte richtig angegeben?
Dim element,tmpBildExtension
Abbruch = false

if flag_selBilder = 1 and FF_GetSelection(1) = "" then
	msgbox "Achtung: Es muss mindestens ein Bild" & vbNewLine & _
		   "in der Computeransicht markiert werden!",vbExclamation,"Warnung"
	Abbruch = true : exit sub
end if

if (flag_selBilder = 1 or flag_allBilder = 1) and flag_OrdnerNeu = 1 then
	if Ablageordner <> "" and FF_GetImagePath() = Ablageordner then
		msgbox "Achtung:" & vbNewLine & _
			   "Der Speicherort ""festes Verzeichnis"" darf nicht" & vbNewLine & _
			   "mit dem Quelleverzeichnis identisch sein!",vbExclamation,"Warnung"
		Abbruch = true : exit sub
	end if
end if

if (flag_selectInBL = 1 or flag_alleInBL = 1) and Bilderliste = "" then
	msgbox "Achtung: Es muss eine Bilderliste aktiv sein!",vbExclamation,"Warnung"
	Abbruch = true : exit sub
end if

if (flag_selectInBL = 1 or flag_alleInBL = 1) and FF_IListGetCount(Bilderliste) = 0 then
	msgbox "Achtung: In der Bilderliste" & vbNewLine & _
			"""" & Bilderliste & """" & vbNewLine & _
			"sind keine Bilder!",vbExclamation,"Warnung"
	Abbruch = true : exit sub
end if

if flag_selectInBL = 1 and FF_GetSelection(3) = "" then		'selektierte Bilder in der Bilderliste
	msgbox "Achtung: In der Bilderliste" & vbNewLine & _
		   """" & Bilderliste & """" & vbNewLine & _
		   "sind keine Bilder selektiert!",vbExclamation,"Warnung"
	Abbruch = true : exit sub
end if

Filteranzeige = ""
Array = split(BildFilter,";")
for each element in Array
	if instr(BildExtension,element) > 0 then
		tmpBildExtension = tmpBildExtension & ";" & element
		Filteranzeige = Filteranzeige & element & "- "
	end if
next

if len(tmpBildExtension) > 1 then
	BildExtension = mid(tmpBildExtension,2)
	FF_SetControl "ScaleAll","BildExtension",BildExtension
else
	msgbox "Beim Bildfilter liegt ein Formatfehler vor!" & vbNewLine & _
		   "Es drfen nur Elemente des Standardfiters " & BildFilter & " verwendet werden." & vbNewLine & _
		   "Bitte korrigieren!",vbExclamation,"Aufforderung"
	Abbruch = true : exit sub
end if

if flag_Unterordner = 1 and Unterordner = "" then
	msgbox "Achtung: Es muss ein Unterordner" & vbNewLine & _
		   "angegeben werden!",vbExclamation,"Warnung"
	Abbruch = true : exit sub
end if

if flag_OrdnerNeu = 1 and Ablageordner = "" then
	msgbox "Achtung: Es muss ein Ablageordner" & vbNewLine & _
		   "angegeben werden!",vbExclamation,"Warnung"
	Abbruch = true : exit sub
end if

if flag_OrdnerNeu = 1 and not objFS.FolderExists(Ablageordner) then
	msgbox "Das Verzeichnis " & Ablageordner & " als Speicherort existiert nicht." & vbNewLine & _
		   "Es muss neu angelegt werden!",vbExclamation,"Aufforderung"
	FF_SetControl "ScaleAll","Ablageordner",""
	Abbruch = true : exit sub
end if

if flag_MaxHoehe = 1 then
	if Bildlaenge = 0 then
		msgbox "Achtung: Es muss ein Wert fr die" & vbNewLine & _
			   "max. Breite angegeben werden!",vbExclamation,"Warnung"
		Abbruch = true : exit sub		
	elseif Bildhoehe = 0 then
		msgbox "Achtung: Es muss ein Wert fr die" & vbNewLine & _
			   "max. Hhe angegeben werden!",vbExclamation,"Warnung"
		Abbruch = true : exit sub
	end if
else
	if Bildlaenge = 0 then
		msgbox "Achtung: Es muss ein Wert fr die" & vbNewLine & _
			   "Seitenlnge angegeben werden!",vbExclamation,"Warnung"
		Abbruch = true : exit sub
	end if
end if

if flag_Praefix = 1 and Praefix = "" then
	msgbox "Achtung: Es muss der Vorspann" & vbNewLine & _
		   "angegeben werden!",vbExclamation,"Warnung"
	Abbruch = true : exit sub
end if

if flag_Suffix = 1  and Suffix = "" then
	msgbox "Achtung: Es muss der Nachspann" & vbNewLine & _
		   "angegeben werden!",vbExclamation,"Warnung"
	Abbruch = true : exit sub
end if

if Qualitaet = "" then
	msgbox "Achtung: Es muss ein Wert fr" & vbNewLine & _
		   "die Qualitt angegeben werden!",vbExclamation,"Warnung"
	Abbruch = true : exit sub
end if

if Qualitaet = 0 or Qualitaet >= 60 and Qualitaet <= 100 then
	'in Ordnung
	else
	msgbox "Achtung: Der Qualittswert muss 0 sein" & vbNewLine & _
		   "oder zwischen 60 und 100 liegen!",vbExclamation,"Warnung"
	Abbruch = true : exit sub
end if

if flag_Schaerfen = 1 and S_ListArray(S_Nummer) = "" then
	msgbox "Zur gewhlten Schrfungsmethode wurden" & vbNewLine & "noch keine Einstellungen vorgenommen!",vbExclamation,"Warnung"
	Abbruch = true : exit sub
end if

End Sub
'------------------------------------------------------------------------
Sub BilderGesamtzahl
'Ermittlung der Gesamtanzahl Bilder
Dim Bildfolge,element

Gesamtanzahl = 0 : Anzahl = 0 : Bilderanzahl = 0
AnzahlZuKlein = 0 : AnzahlGeschuetzt = 0 : AnzahlSkaliert = 0 : AnzahlDefekt = 0

Set objFolder = objFS.GetFolder(FF_GetImagePath())				'aktiver Ordner

'### Selection
'0 = alle Dateien der Computeransicht
'1 = alle selektierten Dateien der Computeransicht
'2 = alle Dateien der aktuellen Bilderliste
'3 = alle selektierten Dateien der aktuellen Bilderliste
'4 = Sonder: alle im akt. Verz. und den Unterverz.

Select Case Selection
	Case 5										'eigentlich Case 0; ungltig gemacht ab V 1.25
		Gesamtanzahl = objfolder.files.count
	Case 0,1,2,3								'ab V 1.25 auch Case 0
		Bildfolge = FF_GetSelection(Selection)
		Array = split(Bildfolge,vbNewLine)
		Gesamtanzahl = ubound(Array) + 1
	Case 4
		call ZaehlerSub (objFolder)
Case else
End select

FF_SetControl "ScaleAll","ZahlBearbeitet",0
FF_SetControl "ScaleAll","ZahlGesamt",Gesamtanzahl

End Sub
'------------------------------------------------------------------------
Sub ZaehlerSub(ByVal myfolder)
'Zhlen der Ordner, Unterordner und Dateien
Dim Pos,Weiter
Weiter = false

if flag_Unterordner = 1 then
	Pos = InStrRev(myfolder,"\")
	if ucase(mid(myfolder,Pos)) = ucase(Unterordner) then Weiter = true
end if

if flag_OrdnerNeu = 1 then
	Pos = InStrRev(myfolder,"\")
	if ucase(mid(myfolder,Pos)) = ucase(Ablageordner) then Weiter = true
end if	

if not Weiter then
	'SubAnzahl = SubAnzahl + 1							'Anzahl Ordner incl. Hauptverz.
	Gesamtanzahl = Gesamtanzahl + myfolder.files.count	'Anzahl Dateien
end if

For Each objSubFolder In myfolder.subfolders
     call ZaehlerSub (objSubFolder)
Next

End Sub
'------------------------------------------------------------------------
Sub ScaleSchleife
Dim Bildfolge

'0 = alle Dateien der Computeransicht
'1 = alle selektierten Dateien der Computeransicht
'2 = alle Dateien der aktuellen Bilderliste
'3 = alle selektierten Dateien der aktuellen Bilderliste
'4 = Sonder: alle im akt. Verz. und den Unterverz.

Select Case Selection
	Case 5												'### gendert ab V 1.16
		for each Bild In objfolder.Files				'ungltig gemacht anb V 1.25 durch Case 5
			Bildfolge = Bildfolge & Bild & vbNewLine
		next
		Array = split(Bildfolge,vbNewLine)
		for each Bild in Array
			if Bild <> "" then call Skalieren_Speichern
			if Abbruch then exit sub
		next
	Case 0,1,2,3										'ab V 1.25 auch Case 0
		Bildfolge = FF_GetSelection(Selection)
		Array = split(Bildfolge,vbNewLine)
		for each Bild in Array
			call Skalieren_Speichern
			if Abbruch then exit sub
		next
	Case 4
		call ShowSubfolder (objFolder,0)
		if Abbruch then exit sub	
Case Else
End Select
	
End Sub
'------------------------------------------------------------------------
Sub ShowSubfolder(ByVal myfolder,ByVal Tiefe)
'Ermittlung aller Dateien  des Ordners
Dim Pos,Weiter,Bildfolge
Weiter = false

if flag_Unterordner = 1 then	'Ausklammern des Speicherorts 'Unterordner des Quellverzeichnis'
	Pos = InStrRev(myfolder,"\")
	if ucase(mid(myfolder,Pos)) = ucase(Unterordner) then Weiter = true
end if

if flag_OrdnerNeu = 1 then		'Ausklammern des Speicherorts 'fester Ordner'
	if ucase(myfolder) = ucase(Ablageordner) then Weiter = true
end if

if not Weiter then
	for each Bild In myfolder.Files				'### gendert ab V 1.16
		Bildfolge = Bildfolge & Bild & vbNewLine
	next
	Array = split(Bildfolge,vbNewLine)
	for each Bild in Array
		if Bild <> "" then call Skalieren_Speichern
		if Abbruch then exit sub
	next
end if

For Each objsubfolder In myfolder.subfolders			'nchste Ebene aufrufen
	ShowSubfolder objSubFolder, Tiefe + 1
Next
	
End Sub
'------------------------------------------------------------------------
Sub Skalieren_Speichern
Dim BildTemp,Bild_Skaliert,strExtension,file,tempAnmerkung,Schreibschutz,BildSicherung
Dim NurKopierenOhneVerlust : NurKopierenOhneVerlust = False

Abbruch = false

'Test ob Bild vorhanden, sonst Abbruch
if not objFS.FileExists(Bild) then
	msgbox "Die Datei" & vbNewLine & Bild & vbNewLine & "wurde bereits gelscht." & vbNewLine & vbNewLine & _
		   "Bitte die Computeransicht aktualisieren" & vbNewLine & "und es dann erneut versuchen!",vbExclamation,"Abbruch"
	Prot_Liste = Prot_Liste & "NV " & Bild & vbNewLine
	Abbruch = true
	exit sub
end if

BildTemp = Bild

'### Abbruch?
if FF_CheckKey() = 8 then 	'8 = Backspace
	Antwort = msgbox("Von " & Gesamtanzahl & " Dateien wurden bisher " & Bilderanzahl & _
					 " Bilder skaliert." & vbNewLine & vbNewLine & _
					 "Soll die Skalierung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
	if Antwort = vbYes then Abbruch = true : exit sub
end if

'### Fortschrittsanzeige
Anzahl = Anzahl + 1
FF_SetControl "ScaleAll","ZahlBearbeitet",Anzahl
FF_SetControl "ScaleAll","FortschrittAnzeige",Anzahl/Gesamtanzahl*100
FF_SetProgress Anzahl,Gesamtanzahl
FF_RefreshDialog("ScaleAll")

'### Bildfilter anwenden
strExtension = ucase(objFS.GetExtensionName(Bild))
if strExtension <> "" and instr(BildExtension,strExtension) > 0 then
	Bilderanzahl = Bilderanzahl + 1
else
	Prot_NichtBearbeitet = Prot_NichtBearbeitet & Bild & vbNewLine
	exit sub
end if

'### Laden
on error resume next
FF_LoadImage(Bild)
if err.number > 0 then
'	Msgbox "Die Bilddatei" & vbNewline & Bild & vbNewLine & "ist defekt.",vbExclamation,"Abbruch"
	Prot_Liste = Prot_Liste & "DF " & Bild & vbNewLine
	AnzahlDefekt = AnzahlDefekt +1
	exit sub
end if
on error goto 0

Set file = objFS.GetFile(Bild)
Datum = file.DateLastModified

'### Schreibschutz abfragen
Schreibschutz = false
if flag_auchBeiSchreibschutz = 0 then
	if flag_OrigLoeschen then
   		If file.attributes and 1 Then 				'Attribut ReadOnly (=1) ist gesetzt
   			Schreibschutz = true
			AnzahlGeschuetzt = AnzahlGeschuetzt + 1
			tempAnmerkung = "SS "
		end if
	end if
end if

'### nur kopieren - verlustfrei?
if flag_nurKopieren = 1 then
	tempAnmerkung = tempAnmerkung & "NK "		'Nur Kopiert
	if flag_speichernAls = 0 or strExtension <> SpeicherExtension then 
		NurKopierenOhneVerlust = true	'verlustfrei mit CopyFile
		tempAnmerkung = tempAnmerkung & "VF "	'VerlustFrei
		BildSicherung = FF_GetScriptPath() & "\" & objFS.GetFileName(Bild)
		objFs.CopyFile Bild,BildSicherung,true
	end if
end if

'### Exif / IPTC  lschen
if NurKopierenOhneVerlust then
	if flag_ExifLoeschen = 1 then FF_KillExifData(BildSicherung)
	if flag_IPTCloeschen = 1 then FF_KillIPTCData(BildSicherung)
end if

'### Skalieren (nur verkleinern?), wenn 'nur kopieren' deaktiviert ist
Bildlaenge = Bildlaenge * 1
Bildhoehe = Bildhoehe * 1
if flag_nurKopieren = 0 then

	select case Crop
		case 0	'lngste Seite
			if flag_nurVerkleinern = 0 or _
			FF_GetImageHeight > Bildlaenge or FF_GetImageWidth > Bildlaenge then
				FF_HQScale Bildlaenge,Bildlaenge,true
			else
				AnzahlZuKlein = AnzahlZuKlein + 1
				tempAnmerkung = tempAnmerkung & "KG "
			end if
		case 1	'krzeste Seite
			if FF_GetImageHeight < FF_GetImageWidth then
				if flag_nurVerkleinern = 0 or _
				FF_GetImageHeight > Bildlaenge then
					FF_HQScale 1000000000,Bildlaenge, true
				else
					AnzahlZuKlein = AnzahlZuKlein + 1
					tempAnmerkung = tempAnmerkung & "KG "
				end if
			else
				if flag_nurVerkleinern = 0 or _
				FF_GetImageWidth() > Bildlaenge then
					FF_HQScale Bildlaenge,100000000, true
				else
					AnzahlZuKlein = AnzahlZuKlein + 1
					tempAnmerkung = tempAnmerkung & "KG "
				end if
			end if
		case 2	'Breite max.
			if flag_nurVerkleinern = 0 or _
			FF_GetImageWidth() > Bildlaenge then
				FF_HQScale Bildlaenge,100000000,true
			else
				AnzahlZuKlein = AnzahlZuKlein + 1
				tempAnmerkung = tempAnmerkung & "KG "
			end if
		case 3	'Hhe max.
			if flag_nurVerkleinern = 0 or _
			FF_GetImageHeight > Bildlaenge then
				FF_HQScale 100000000,Bildlaenge,true
			else
				AnzahlZuKlein = AnzahlZuKlein + 1
				tempAnmerkung = tempAnmerkung & "KG "
			end if
		case 4	'max. Breite + max. Hhe
			if flag_nurVerkleinern = 0 or _
			FF_GetImageWidth() > Bildlaenge or _
			FF_GetImageHeight > Bildhoehe then
				FF_HQScale Bildlaenge,Bildhoehe,true
			else
				AnzahlZuKlein = AnzahlZuKlein + 1
				tempAnmerkung = tempAnmerkung & "KG "
			end if				
				
	case else
	end select
end if

AnzahlSkaliert = AnzahlSkaliert + 1

'### Schrfen
if flag_Schaerfen = 1 then
	ParamWerte = split(S_ListArray(S_Nummer),",")
	select case S_Nummer
		Case 0
			FF_YSharp ParamWerte(0)
		Case 1
			FF_Sharp ParamWerte(0),ParamWerte(1),ParamWerte(2),ParamWerte(3)
		case 2
			FF_USMSharp ParamWerte(0),ParamWerte(1),ParamWerte(2),ParamWerte(3),ParamWerte(4),ParamWerte(5)
		case 3
			FF_GeoSharp ParamWerte(0)
		case 4
			FF_SmartSharp ParamWerte(0),ParamWerte(1)
		case 5
			FF_HamiltonSharp ParamWerte(0),ParamWerte(1)
		case 6
			FF_3DSharp ParamWerte(0),ParamWerte(1)
	case else
	end select
end if

'### Speichern vorbereiten
'Pfad
if flag_OrdnerGleich = 1 then
	Pfad = objFS.GetParentFolderName(Bild) & "\"
elseif flag_Unterordner = 1 then
	Pfad = objFS.GetParentFolderName(Bild) & Unterordner & "\"
	if not objfs.FolderExists(Pfad) then
		objfs.CreateFolder(Pfad)
		OrdnerNeu = true
	End if
else
	Pfad = Ablageordner & "\"
end if

'Extension
if flag_speichernAls = 1 then 
	strExtension = "." & SpeicherExtension
else
	strExtension = "." & strExtension
end if

'Pfad und Datei ohne Extension
if flag_Praefix = 1 then
	Bild_Skaliert = Pfad & Praefix & objFS.GetBaseName(Bild)
elseif flag_Suffix = 1 then
	Bild_Skaliert = Pfad & objFS.GetBaseName(Bild) & Suffix
else
	Bild_Skaliert = Pfad & objFS.GetBaseName(Bild)
end if

'### vorhandene Bilder nummerieren mit (1), (2) usw.
if objFS.FileExists(Bild_Skaliert & strExtension) and flag_OrigLoeschen = 0 then
	n = 1
	do
		if not objFS.FileExists(Bild_Skaliert & "(" & n & ")" & strExtension) then exit do
		n = n + 1
	loop
	Bild_Skaliert = Bild_Skaliert & "(" & n & ")" & strExtension
else
	Bild_Skaliert = Bild_Skaliert & strExtension
end if

'### Skaliertes Bild speichern

if NurKopierenOhneVerlust then
	objFS.MoveFile BildSicherung,Bild_Skaliert
else
	if strExtension = ".TIF" then
		if flag_TifLZW = 1 then
			FF_SaveImage Bild_Skaliert,0
		elseif flag_TifUnkomp = 1 then
			FF_SaveImage Bild_Skaliert,1
		end if
	else
		FF_SaveImage Bild_Skaliert,Qualitaet
		if flag_ExifLoeschen = 1 then FF_KillExifData Bild_Skaliert
		if flag_IPTCLoeschen = 1 then FF_KillIPTCData Bild_Skaliert
	end if
end if

if flag_Datum_bleibt = 1 then call SetDatum(Bild_Skaliert,Datum)

'### Originaldatei lschen bzw. aus der Bilderliste entfernen
if flag_OrigLoeschen = 1 and not Schreibschutz then
	tempAnmerkung = tempAnmerkung & "GL "
	
	if flag_OrdnerGleich = 0 or flag_Praefix = 1 or flag_Suffix = 1 then 
		objFS.DeleteFile(Bild),true								' ,true = auch bei Schreibschutz lschen
																' ,false = bei Schreibschutz nicht lschen (Standard)
	end if
end if

if flag_inBLnurEntfernen = 1 then 
	FF_IListDeleteFile Bilderliste, Bild
	tempAnmerkung = tempAnmerkung & "EF "
end if

'### Protokollierung der Originaldatei
if tempAnmerkung = "" then tempAnmerkung = "UV "
Prot_Liste = Prot_Liste & tempAnmerkung & BildTemp & vbNewLine

'### Protokollierung der Zieldatei
Prot_Liste = Prot_Liste & ">> " & Bild_Skaliert & vbNewLine

'### Abbruch-Protokollierung der bearbeiteten Datei
'Set DateiA = objFS.OpenTextFile(ProtAbb_Datei, ForAppending, true)
DateiA.Write BildTemp & vbNewLine
'DateiA.Close

End Sub
'------------------------------------------------------------------------
Sub ProtokollErstellung
Prot_Gesamt = ""

Prot_Zeile(1) =  Prot_Zeile(1) & Gesamtanzahl  & vbNewLine & vbNewLine

for n = 0 to 14
	Prot_Gesamt = Prot_Gesamt & Prot_Zeile(n)
next

Prot_Gesamt = Prot_Gesamt & vbNewLine & "Legende:" & vbNewLine & _
										"UV - unverndert" & vbNewLine & _
										"NV - nicht vorhanden" & vbNewLine & _
										"DF - defekt" & vbNewLine & _
										"SS - Schreibschutz" & vbNewLine & _
										"KG - kleiner als gefordert" & vbNewLine & _
										"GL - Original gelscht" & vbNewLine & _
										"EF - aus Bilderliste entfernt" & vbNewLine & _
										"NK - nur kopieren" & vbNewLine & _
										"VF - verlustfrei" & vbNewLine & _
										">> - gespeichert als ..." & vbNewLine & vbNewLine
Prot_Gesamt = Prot_Gesamt & Prot_Liste & vbNewLine
if Prot_NichtBearbeitet <> "" then
	Prot_Gesamt = Prot_Gesamt & "Nicht bearbeitete Dateien:" & vbNewLine & Prot_NichtBearbeitet & vbNewLine
end if

Prot_Gesamt = Prot_Gesamt & _
	"Dateien gesamt: " & GesamtAnzahl & vbNewLine & _
	"gefiltert mit: " & BildExtension & vbNewLine & _
	"ergibt passende Bilder: " & Bilderanzahl & vbNewLine & vbNewLine & _
	"Gespeichert: " & AnzahlSkaliert & vbNewLine

if flag_OrigLoeschen = 1 and flag_auchBeiSchreibschutz = 0 then
	Prot_Gesamt = Prot_Gesamt & _
		"Wegen Schreibschutz nicht gelscht: " & AnzahlGeschuetzt  & vbNewLine
end if

if flag_nurVerkleinern = 1 and flag_nurKopieren = 0 then
	Prot_Gesamt = Prot_Gesamt & _
		"Nicht verkleinert weil bereits kleiner: " & AnzahlZuKlein  & vbNewLine
end if	
		
if Abbruch then
	Prot_Gesamt = Prot_Gesamt & vbNewLine & "Die Bearbeitung wurde vorzeitig abgebrochen!" & vbNewLine
end if

Prot_Gesamt = Prot_Gesamt & vbNewLine & Now

'Protokolldatei anlegen
Dim Datei

Set Datei = objFS.OpenTextFile(Prot_Datei, ForWriting, true)
Datei.Write Prot_Gesamt
Datei.Close

End Sub
'------------------------------------------------------------------------
'############################### Registry ###############################
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_ScaleAll
Dim element

'Werte aus Registry auslesen
Version 		= FF_GetProfile("FF_ScaleAll","Version")
Auswahl 		= FF_GetProfile("FF_ScaleAll","Auswahl")		'5 Werte
BildExtension	= FF_GetProfile("FF_ScaleAll","BildExtension")
Speicherort 	= FF_GetProfile("FF_ScaleAll","Speicherort")	'3 Werte
Unterordner		= FF_GetProfile("FF_ScaleAll","Unterordner")
Ablageordner 	= FF_GetProfile("FF_ScaleAll","Ablageordner")
Crop		 	= FF_GetProfile("FF_ScaleAll","Crop")
Bildlaenge 		= FF_GetProfile("FF_ScaleAll","Bildlaenge")
Bildhoehe 		= FF_GetProfile("FF_ScaleAll","Bildhoehe")
	if Bildhoehe = "" then Bildhoehe = Bildhoehe = "100"
Praefix 		= FF_GetProfile("FF_ScaleAll","Praefix")
Suffix 			= FF_GetProfile("FF_ScaleAll","Suffix")
BildHandling 	= FF_GetProfile("FF_ScaleAll","BildHandling")	'5 Werte
Speicherparameter = FF_GetProfile("FF_ScaleAll","Speicherparameter")	'3 Werte
SpeicherExtension = FF_GetProfile("FF_ScaleAll","SpeicherExtension")
flag_Protokoll	= FF_GetProfile("FF_ScaleAll","flag_Protokoll")
Qualitaet 		= FF_GetProfile("FF_ScaleAll","Qualitaet")
flag_Schaerfen	= FF_GetProfile("FF_ScaleAll","flag_Schaerfen")
	if flag_Schaerfen = "" then flag_Schaerfen = 0
S_Nummer		= FF_GetProfile("FF_ScaleAll","S_Nummer")
	if S_Nummer = "" then S_Nummer = 0
	S_Nummer	= S_Nummer *1
S_ParamListe	= FF_GetProfile("FF_ScaleAll","S_ParamListe")
	if len(S_ParamListe) = 0 then S_ParamListe = "||||||"
	S_ListArray = split(S_ParamListe,"|")
Daten_Delete	= FF_GetProfile("FF_ScaleAll","Daten_Delete")	'2 Werte

'Alternative wenn keine Registrywerte vorhanden
if Version <> ">1.13" then
	Auswahl 		= "1/0/0/0/0"
	BildExtension 	= BildFilter
	Speicherort 	= "1/0/0"
	Unterordner		= "\verkleinert"
	Ablageordner 	= FF_GetScriptPath
	Crop			= 0
	Bildlaenge 		= "500"
	Praefix 		= "Mini_"
	Suffix 			= "_Mini"
	BildHandling 	= "1/0/0/0/0"
	Speicherparameter = "1/0/0"
	SpeicherExtension = "JPG"
	flag_Protokoll	  = "1"
	Qualitaet 		= "80"
	Daten_Delete	= "1/1"
end if
if Speicherparameter = "1/0" then Speicherparameter = "1/0/0"

'Arrays auflsen
Array = split(Auswahl,"/")
	flag_selBilder		= Array(0)
	flag_allBilder		= Array(1)
	flag_allBilderUV	= Array(2)
	flag_selectInBL		= Array(3)
	flag_alleInBL		= Array(4)
Array = split(Speicherort,"/")
	flag_OrdnerGleich	= Array(0)
	flag_Unterordner	= Array(1)
	flag_OrdnerNeu		= Array(2)
Array = split(BildHandling,"/")
	flag_Praefix		= Array(0)
	flag_Suffix			= Array(1)
	flag_OrigLoeschen	= Array(2)
	flag_auchBeiSchreibschutz	= Array(3)
	flag_inBLnurEntfernen		= Array(4)
Array = split(Speicherparameter,"/")
	flag_nurVerkleinern	= Array(0)
	flag_speichernAls	= Array(1)
	flag_Datum_bleibt	= Array(2)
Array = split(Daten_Delete,"/")
	flag_ExifLoeschen	= Array(0)
	flag_IPTCloeschen	= Array(1)

'Werte in Dialog eintragen
'Auswahl
FF_SetControl "ScaleAll","flag_selBilder",flag_selBilder
if flag_selBilder = 1 then FF_EnableControl "ScaleAll","flag_inBLnurEntfernen",false
FF_SetControl "ScaleAll","flag_allBilder",flag_allBilder
if flag_allBilder = 1 then FF_EnableControl "ScaleAll","flag_inBLnurEntfernen",false
FF_SetControl "ScaleAll","flag_allBilderUV",flag_allBilderUV
if flag_allBilderUV = 1 then FF_EnableControl "ScaleAll","flag_inBLnurEntfernen",false
FF_SetControl "ScaleAll","flag_selectInBL",flag_selectInBL
if flag_selectInBL = 1 then FF_EnableControl "ScaleAll","flag_inBLnurEntfernen",true
FF_SetControl "ScaleAll","flag_alleInBL",flag_alleInBL
if flag_alleInBL = 1 then FF_EnableControl "ScaleAll","flag_inBLnurEntfernen",true
'Bildfilter
FF_SetControl "ScaleAll","BildExtension",BildExtension
'Speicherort
FF_SetControl "ScaleAll","flag_OrdnerGleich",flag_OrdnerGleich
FF_SetControl "ScaleAll","flag_Unterordner",flag_Unterordner
FF_SetControl "ScaleAll","Unterordner",Unterordner
FF_SetControl "ScaleAll","flag_OrdnerNeu",flag_OrdnerNeu
FF_SetControl "ScaleAll","Ablageordner",Ablageordner
'Skalierauswahl und Bildlnge
Array = split(CropAuswahl,"/")
for n = 0 to 4
	FF_SetControl "ScaleAll","Skalierwert",Array(n)
next
FF_SetControl "ScaleAll","Skalierwert",Array(Crop)
	if Array(Crop) = "max.Breite +" then
		FF_SetControl "ScaleAll","flag_MaxHoehe",1
		FF_EnableControl "ScaleAll","HheMax",true
	else
		FF_SetControl "ScaleAll","flag_MaxHoehe",0
		FF_EnableControl "ScaleAll","HheMax",false
	end if
FF_SetControl "ScaleAll","Lnge",Bildlaenge
FF_SetControl "ScaleAll","HheMax",Bildhoehe
'Prfix und Suffix
FF_SetControl "ScaleAll","Prfix",Praefix
FF_SetControl "ScaleAll","Suffix",Suffix
'Bildhandling
FF_SetControl "ScaleAll","flag_Praefix",flag_Praefix
FF_SetControl "ScaleAll","flag_Suffix",flag_Suffix
FF_SetControl "ScaleAll","flag_OrigLschen",flag_OrigLoeschen
if flag_OrigLoeschen = 0 then FF_EnableControl "ScaleAll","flag_auchBeiSchreibschutz",false
FF_SetControl "ScaleAll","flag_auchBeiSchreibschutz",flag_auchBeiSchreibschutz
FF_SetControl "ScaleAll","flag_inBLnurEntfernen",flag_inBLnurEntfernen
'Speicherparameter
FF_SetControl "ScaleAll","flag_nurVerkleinern",flag_nurVerkleinern
FF_SetControl "ScaleAll","flag_speichernAls",flag_speichernAls
FF_SetControl "ScaleAll","flag_Datum_bleibt",flag_Datum_bleibt
'----
Array = split(BildFilter,";")
for each element in Array
	FF_SetControl "ScaleAll","SpeicherExtension",element
next
FF_SetControl "ScaleAll","SpeicherExtension",SpeicherExtension
'flag_Protokoll
FF_SetControl "ScaleAll","flag_Protokoll",flag_Protokoll
'JPEG-Qualitt
FF_SetControl "ScaleAll","QualittsWert",Qualitaet
'Schrfe
FF_SetControl "ScaleAll","flag_Schaerfen",flag_Schaerfen
FF_SetControl "ScaleAll","S_Auswahl",S_Array(S_Nummer)
'Daten_Delete
FF_SetControl "ScaleAll","flag_ExifLschen",flag_ExifLoeschen
FF_SetControl "ScaleAll","flag_IPTClschen",flag_IPTCloeschen

End Sub
'------------------------------------------------------------------------
Sub Werte_Auslesen
'und Protokoll vorbereiten
Dim CropTmp

Prot_Zeile(0) = "ScaleAll-Protokoll vom " & Now & vbNewLine & vbNewLine & "Quelle:" & vbNewLine

'aktuelle Bilderliste
Bilderliste = FF_IListGetCurrentList()

'Auswahl
flag_selBilder		= FF_GetControl("ScaleAll","flag_selBilder")	'1 = alle selektierten Dateien der Computeransicht
	if flag_selBilder = 1 then 
		Selection = 1
		Prot_Zeile(1) = "Selektierte Bilder im aktuellen Verzeichnis: "
	end if
flag_allBilder		= FF_GetControl("ScaleAll","flag_allBilder")	'0 = alle Dateien der Computeransicht
	if flag_allBilder = 1 then 
		Selection = 0
		Prot_Zeile(1) = "Alle Dateien im aktuellen Verzeichnis: "
	end if
flag_allBilderUV	= FF_GetControl("ScaleAll","flag_allBilderUV")	'4 = Sonder: alle im akt. Verz. und den Unterverz.
	if flag_allBilderUV = 1 then 
		Selection = 4
		Prot_Zeile(1) = "Dateien im aktuellen Verzeichnis und in dessen Unterverzeichnissen: "
	end if
flag_selectInBL		= FF_GetControl("ScaleAll","flag_selectInBL")	'3 = alle selektierten Dateien der aktuellen Bilderliste
	if flag_selectInBL = 1 then 
		Selection = 3
		Prot_Zeile(1) = "Selektierte Bilder in Bilderliste " & Bilderliste & " : "
	end if
flag_alleInBL		= FF_GetControl("ScaleAll","flag_alleInBL")		'2 = alle Dateien der aktuellen Bilderliste
	if flag_alleInBL = 1 then 
		Selection = 2
		Prot_Zeile(1) = "Alle Bilder in Bilderliste " & Bilderliste & " : "
	end if

'Bildfilter
BildExtension		= ucase(FF_GetControl("ScaleAll","BildExtension"))
Prot_Zeile(2) = "Zugelassene Dateierweiterungen: " & BildExtension & vbNewLine

'Speicherort
flag_OrdnerGleich 	= FF_GetControl("ScaleAll","flag_OrdnerGleich")
	if flag_OrdnerGleich = 1 then
		Prot_Zeile(3) = "Speicherort: Quellverzeichnis" & vbNewLine
	end if
flag_Unterordner	= FF_GetControl("ScaleAll","flag_Unterordner")
Unterordner			= FF_GetControl("ScaleAll","Unterordner")
	if flag_Unterordner = 1 then
		Prot_Zeile(3) = "Speicherort: Unterordner """ & Unterordner & """ des Quellverzeichnis" & vbNewLine
	end if
flag_OrdnerNeu		= FF_GetControl("ScaleAll","flag_OrdnerNeu")
Ablageordner 		= FF_GetControl("ScaleAll","Ablageordner")
	if flag_OrdnerNeu = 1 then
		Prot_Zeile(3) = "Speicherort: Fester Ordner " & Ablageordner & vbNewLine
	end if

'Bildlnge
CropTmp		 		= FF_GetControl("ScaleAll","Skalierwert")
CropArray = split(CropAuswahl,"/")
for n = 0 to 4
	if CropTmp =  CropArray(n) then Crop = n
next

if Crop = 4 then flag_MaxHoehe = 1 else flag_MaxHoehe = 0
FF_SetControl "ScaleAll","flag_MaxHoehe",flag_MaxHoehe

Bildlaenge 			= FF_GetControl("ScaleAll","Lnge")
if Bildlaenge = "" then Bildlaenge = 0 : Bildlaenge = Bildlaenge *1
Bildhoehe 			= FF_GetControl("ScaleAll","HheMax")
if Bildhoehe = "" then Bildhoehe = 0 : Bildhoehe = Bildhoehe *1

	if FF_GetControl("ScaleAll","flag_MaxHoehe") = 1 then
		Prot_Zeile(4) = "Skalierung: " & CropTmp & " " & Bildlaenge & " px / " & "max. Hhe " & Bildhoehe & " px" & vbNewLine
	else
		Prot_Zeile(4) = "Skalierung: " & CropTmp & " " & Bildlaenge & " Pixel" & vbNewLine
	end if

'Prfix und Suffix
Praefix 			= FF_GetControl("ScaleAll","Prfix")
Suffix 				= FF_GetControl("ScaleAll","Suffix")

'BildHandling
flag_Praefix		= FF_GetControl("ScaleAll","flag_Praefix")
flag_Suffix			= FF_GetControl("ScaleAll","flag_Suffix")
	if flag_Praefix = 1 then
		Prot_Zeile(5) = "Vorspann fr zu speichernde Bilder: """ & Praefix & """ " & vbNewLine
	elseif flag_Suffix = 1 then
		Prot_Zeile(5) = "Nachspann fr zu speichernde Bilder: """ &  Suffix & """ " & vbNewLine
	else
		Prot_Zeile(5) = "Vor-/Nachspann fr zu speichernde Bilder: nicht aktiviert" & vbNewLine
	end if

Prot_Zeile(6) = ""
flag_OrigLoeschen	= FF_GetControl("ScaleAll","flag_OrigLschen")
flag_auchBeiSchreibschutz = FF_GetControl("ScaleAll","flag_auchBeiSchreibschutz")
	if flag_OrigLoeschen = 1 then
		if flag_auchBeiSchreibschutz = 1 then
			Prot_Zeile(6) = "Originaldateien: lschen, auch bei Schreibschutz"  & vbNewLine
		else
			Prot_Zeile(6) = "Originaldateien: lschen, sofern ohne Schreibschutz"  & vbNewLine
		end if
	end if
flag_inBLnurEntfernen	  = FF_GetControl("ScaleAll","flag_inBLnurEntfernen")
	if flag_inBLnurEntfernen = 1 then
		Prot_Zeile(6) = "Gewhlte Bilder in Bilderliste " & Bilderliste & ": entfernen" & vbNewLine
	end if

if Prot_Zeile(6) = "" then Prot_Zeile(6) = "Lschfunktion: keine aktiviert" & vbNewLine

'Speicherparameter
flag_nurVerkleinern	= FF_GetControl("ScaleAll","flag_nurVerkleinern")
	if flag_nurVerkleinern = 1 then
		Prot_Zeile(7) = "Kleinere Bilder: keine Skalierung" & vbNewLine
	else
		Prot_Zeile(7) = "Kleinere Bilder: vergrern" & vbNewLine
	end if
flag_speichernAls	= FF_GetControl("ScaleAll","flag_speichernAls")
SpeicherExtension	= ucase(FF_GetControl("ScaleAll","SpeicherExtension"))
	if flag_speichernAls = 1 then
		Prot_Zeile(8) = "Speicherung der Bilder: als " & SpeicherExtension & "-Datei" & vbNewLine
	else
		Prot_Zeile(8) = "Speicherung der Bilder: im Originalformat" & vbNewLine
	end if
flag_Datum_bleibt	= FF_GetControl("ScaleAll","flag_Datum_bleibt")

'flag_Protokoll
flag_Protokoll		= FF_GetControl("ScaleAll","flag_Protokoll")

'JPEG-Qualitt
Qualitaet 			= FF_GetControl("ScaleAll","QualittsWert")
	Prot_Zeile(9) = "JPEG-Speicherqualitt: " & Qualitaet & " (0 = FF-Einstellung)" & vbNewLine

'TIFF-Qualitt
	if flag_TifLZW = 1 then
		Prot_Zeile(10) = "TIFF-Komprimierung: LZW-Komprimierung" & vbNewLine
	end if
	if flag_TifUnkomp = 1 then
		Prot_Zeile(10) = "TIFF-Komprimierung: unkomprimiert" & vbNewLine
	end if

'Schrfen
flag_Schaerfen		= FF_GetControl("ScaleAll","flag_Schaerfen")
S_Wahl				= FF_GetControl("ScaleAll","S_Auswahl")
	for n = 0 to S_Max
		if S_Wahl = S_Array(n) then
			S_Nummer = n
			exit for
		end if
	next

	if flag_Schaerfen = 1 then
		Prot_Zeile(11) = "Schrfung: " & S_Array(S_Nummer) & vbNewLine
	else
		Prot_Zeile(11) = "Schrfung: keine" & vbNewLine
	end if

'Daten_Delete
flag_ExifLoeschen	= FF_GetControl("ScaleAll","flag_ExifLschen")
	if flag_ExifLoeschen = 1 then
		Prot_Zeile(12) = "Exif-Daten: lschen" & vbNewLine
	else
		Prot_Zeile(12) = "Exif-Daten: erhalten" & vbNewLine
	end if
flag_IPTCloeschen	= FF_GetControl("ScaleAll","flag_IPTClschen")
	if flag_IPTCloeschen = 1 then
		Prot_Zeile(13) = "IPTC-Daten: lschen" & vbNewLine
	else
		Prot_Zeile(13) = "IPTC-Daten: erhalten" & vbNewLine
	end if
	
flag_nurKopieren = FF_GetControl("ScaleAll","flag_nurKopieren")
	if flag_nurKopieren = "1" then
		Prot_Zeile(14) = vbNewLine & "Achtung: Sonderfunktion 'nur kopieren' ist aktiviert." & vbNewLine
		Prot_Zeile(4) = ""
		Prot_Zeile(7) = ""
	else
		Prot_Zeile(14) = ""
	end if

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_ScaleAll
Dim element,tmpBildExtension

'ggf. Bildfilter kontrollieren
BildExtension = FF_GetControl("ScaleAll","BildExtension")
Array = split(BildFilter,";")
for each element in Array
	if instr(BildExtension,element) > 0 then
		tmpBildExtension = tmpBildExtension & ";" & element
	end if
next

if len(tmpBildExtension) > 1 then
	BildExtension = mid(tmpBildExtension,2)
	FF_SetControl "ScaleAll","BildExtension",BildExtension
end if

call Werte_Auslesen

'Werte zusammenstellen
Auswahl 		= flag_selBilder & "/" & flag_allBilder & "/" & flag_allBilderUV & "/" & _
				  flag_selectInBL & "/" & flag_alleInBL
Speicherort 	= flag_OrdnerGleich & "/" & flag_Unterordner & "/" & flag_OrdnerNeu
BildHandling	= flag_Praefix & "/" & flag_Suffix & "/" & flag_OrigLoeschen & "/" & _
				  flag_auchBeiSchreibschutz & "/" & flag_inBLnurEntfernen
Speicherparameter = flag_nurVerkleinern & "/" & flag_speichernAls & "/" & flag_Datum_bleibt
Daten_Delete	= flag_ExifLoeschen	& "/" & flag_IPTCloeschen
S_ParamListe 	= join(S_ListArray,"|")

FF_WriteProfile "FF_ScaleAll","Version",">1.13"
FF_WriteProfile "FF_ScaleAll","Auswahl",Auswahl
FF_WriteProfile "FF_ScaleAll","BildExtension",BildExtension
FF_WriteProfile "FF_ScaleAll","Speicherort",Speicherort
FF_WriteProfile "FF_ScaleAll","Unterordner",Unterordner
FF_WriteProfile "FF_ScaleAll","Ablageordner",Ablageordner
FF_WriteProfile "FF_ScaleAll","Crop",Crop
FF_WriteProfile "FF_ScaleAll","Bildlaenge",Bildlaenge
FF_WriteProfile "FF_ScaleAll","Bildhoehe",Bildhoehe
FF_WriteProfile "FF_ScaleAll","Praefix",Praefix
FF_WriteProfile "FF_ScaleAll","Suffix",Suffix
FF_WriteProfile "FF_ScaleAll","BildHandling",BildHandling
FF_WriteProfile "FF_ScaleAll","Speicherparameter",Speicherparameter
FF_WriteProfile "FF_ScaleAll","SpeicherExtension",SpeicherExtension
FF_WriteProfile "FF_ScaleAll","flag_Protokoll",flag_Protokoll
FF_WriteProfile "FF_ScaleAll","Qualitaet",Qualitaet
FF_WriteProfile "FF_ScaleAll","flag_Schaerfen",flag_Schaerfen
FF_WriteProfile "FF_ScaleAll","S_Nummer",S_Nummer
FF_WriteProfile "FF_ScaleAll","S_ParamListe",S_ParamListe
FF_WriteProfile "FF_ScaleAll","Daten_Delete",Daten_Delete

End Sub
'------------------------------------------------------------------------
'####################### Versionskontrolle ##############################
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
Dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
'################# Test auf unzulssige Zeichen #########################
'------------------------------------------------------------------------
Function ZulaessigeZeichen (File_Foldername)
Dim Zeichen,Element

Zeichen = split(VerbZ,",")
for each Element in Zeichen
	if instr(File_Foldername,Element) > 0 then
		ZulaessigeZeichen = false
		exit function
	end if
next

if instr(File_Foldername,"""") > 0 then
	ZulaessigeZeichen = false
	exit function
end if

ZulaessigeZeichen = true

End Function
'------------------------------------------------------------------------
'########################################################################
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad
const RegSchluessel = "\FF_ScaleAll\"

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
TempFile = Prot_Datei	'Protokolldatei
if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'TempFile = FF_GetScriptPath & "\BeipackSammlung"		'Ordnerbeispiel
'if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script" & RegSchluessel
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
		Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Sub SetDatum (ByVal DateiKomplett,ByVal Datum)
' setzt das Datum des letzten Zugriffs fr eine Datei
' Parameter: Pfad zu der Datei, Datename, Datum bzw. Datum und Zeit (z.B. "01.04.1999 12:30:15"

	Dim pos,Pfad,Datei
	Dim objFolder, objFolderItem
    
	pos = InStrRev(DateiKomplett,"\")
	Pfad = left(DateiKomplett,pos -1)
	Datei = mid(DateiKomplett,pos +1)

	Set objFolder = objShell.NameSpace(Pfad)
	Set objFolderItem = objFolder.ParseName(Datei)

	objFolderItem.ModifyDate = Datum

End Sub

'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
